using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using IHSTI.MSMQMessaging;
using System.Collections.Specialized;
using MSMQCommon;



namespace MSMQReceiver
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox tbMessage;
		private System.Windows.Forms.Button btnFetchNumeric;
		private System.Windows.Forms.Button btnFetchStrings;
		private System.Windows.Forms.Button btnFetchBogObject;
		private System.Windows.Forms.Button btnFetchRecord;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnFetchStrings = new System.Windows.Forms.Button();
			this.tbMessage = new System.Windows.Forms.TextBox();
			this.btnFetchRecord = new System.Windows.Forms.Button();
			this.btnFetchNumeric = new System.Windows.Forms.Button();
			this.btnFetchBogObject = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnFetchStrings
			// 
			this.btnFetchStrings.Location = new System.Drawing.Point(40, 280);
			this.btnFetchStrings.Name = "btnFetchStrings";
			this.btnFetchStrings.Size = new System.Drawing.Size(232, 23);
			this.btnFetchStrings.TabIndex = 1;
			this.btnFetchStrings.Text = "Fetch String Colection";
			this.btnFetchStrings.Click += new System.EventHandler(this.btnFetchStrings_Click);
			// 
			// tbMessage
			// 
			this.tbMessage.Location = new System.Drawing.Point(40, 16);
			this.tbMessage.Multiline = true;
			this.tbMessage.Name = "tbMessage";
			this.tbMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.tbMessage.Size = new System.Drawing.Size(232, 248);
			this.tbMessage.TabIndex = 3;
			this.tbMessage.Text = "";
			// 
			// btnFetchRecord
			// 
			this.btnFetchRecord.Location = new System.Drawing.Point(40, 352);
			this.btnFetchRecord.Name = "btnFetchRecord";
			this.btnFetchRecord.Size = new System.Drawing.Size(232, 23);
			this.btnFetchRecord.TabIndex = 8;
			this.btnFetchRecord.Text = "Fetch as Record";
			this.btnFetchRecord.Click += new System.EventHandler(this.btnFetchRecord_Click);
			// 
			// btnFetchNumeric
			// 
			this.btnFetchNumeric.Location = new System.Drawing.Point(40, 320);
			this.btnFetchNumeric.Name = "btnFetchNumeric";
			this.btnFetchNumeric.Size = new System.Drawing.Size(232, 23);
			this.btnFetchNumeric.TabIndex = 9;
			this.btnFetchNumeric.Text = "Fetch numeric array";
			this.btnFetchNumeric.Click += new System.EventHandler(this.btnFetchNumeric_Click);
			// 
			// btnFetchBogObject
			// 
			this.btnFetchBogObject.Location = new System.Drawing.Point(40, 384);
			this.btnFetchBogObject.Name = "btnFetchBogObject";
			this.btnFetchBogObject.Size = new System.Drawing.Size(232, 23);
			this.btnFetchBogObject.TabIndex = 10;
			this.btnFetchBogObject.Text = "Fetch Big Object";
			this.btnFetchBogObject.Click += new System.EventHandler(this.btnFetchBogObject_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(292, 424);
			this.Controls.Add(this.btnFetchBogObject);
			this.Controls.Add(this.btnFetchNumeric);
			this.Controls.Add(this.btnFetchRecord);
			this.Controls.Add(this.tbMessage);
			this.Controls.Add(this.btnFetchStrings);
			this.Name = "Form1";
			this.Text = "Message Fetcher";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private void NoMessage()
		{
			tbMessage.Text += "No message waiting" + Environment.NewLine;
		}

		private void btnFetchStrings_Click(object sender, System.EventArgs e)
		{
			try
			{
				StringCollection list = (StringCollection) (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ).ReadMessage(typeof(StringCollection));
				if (list==null)
					NoMessage();
				else
					for (int i=0; i<list.Count; i++)
						tbMessage.Text+=list[i]+ Environment.NewLine;
				 
			}
			catch (System.Exception ex)
			{
				tbMessage.Text = ex.Message;
			}
		}

		
		private void btnFetchRecord_Click(object sender, System.EventArgs e)
		{
			try
			{
					Record list = 
						(MSMQCommon.Record) 
						           (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ)
						                               .ReadMessage(typeof(MSMQCommon.Record));
				    if (list==null)
						NoMessage();
					else
					{
						tbMessage.Text   = list.item1  + Environment.NewLine;
						tbMessage.Text  += list.item2.ToString()+ Environment.NewLine;
						tbMessage.Text  += list.item3 + Environment.NewLine;
					}
				}
			catch (System.Exception ex)
			{
				  
				tbMessage.Text = ex.Message;
			}
		
		}

		private void btnFetchNumeric_Click(object sender, System.EventArgs e)
		{
			/* msgQueue = new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ;
			   int[] theArray= (int[])msgQueue.ReadMessage(typeof(int[])); */
			
			int[] theArray= (int[]) (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ).ReadMessage(typeof(int[]));
			if (theArray==null)
				NoMessage();
			else
				for (int i=0; i<theArray.Length; i++)
					tbMessage.Text += theArray[i].ToString() + Environment.NewLine;
	


		}

		private void btnFetchBogObject_Click(object sender, System.EventArgs e)
		{
			MSMQCommon.BigObjectThing bigObject = (MSMQCommon.BigObjectThing) (new MSMQ(Common.queueName,Common.queueLabel) as IMSMQ).ReadMessage(typeof(MSMQCommon.BigObjectThing));
			if (bigObject==null)
				NoMessage();
			else
			{
				tbMessage.Text = "String Collection:" + Environment.NewLine;
				for (int i=0; i<bigObject.strColl.Count; i++)
					tbMessage.Text += bigObject.strColl[i] + Environment.NewLine;
				tbMessage.Text += "Record:" + Environment.NewLine;
				tbMessage.Text += bigObject.record.item1 + Environment.NewLine;
				tbMessage.Text += bigObject.record.item2 + Environment.NewLine;
				tbMessage.Text += bigObject.record.item3 + Environment.NewLine;
			}
		}
	}
}
